var activeTabClassName='currentTab';
var leftActiveTabClassName='currentTabLeft';
var rightActiveTabClassName='currentTabRight';
var linkActiveTabClassName="currentTabLink";

var inactiveTabClassName='otherTab';
var leftInactiveTabClassName='otherTabLeft';
var rightInactiveTabClassName='otherTabRight';
var linkInactiveTabClassName="otherTabLink";

/***
 * Decide if I hide or show a tab
 * @params:
 * 		visibility as String
 * @return:
 *		style to apply for one form
 ***/
function getVisibility(visibility){
	if(visibility.toUpperCase()=='NO') return 'none'; //hide a form
	else return 'block'; //show a form
}

/***
 * Set class name for a Link (tag 'a')
 * @params:
 * 		links as HTMLCollection Object,
 * 		type  as String
 * @return:
 ***/
function setLinkClassName(links,type){
	for(i=0;i<links.length;i++){
		links[i].className=(type=='Active')?linkActiveTabClassName:linkInactiveTabClassName;
	}
}


/***
 * Set the class name for one tab
 * @params:
 * 		tabLeft   as HTML Object
 * 		tabCenter as HTML Object
 * 		tabRight  as HTML Object
 * 		type      as String
 * @return:
 ***/
function setClassName(tabLeft,tabCenter,tabRight,link,type){

	(tabLeft!=null)?tabLeft.className=(type=='Active')?leftActiveTabClassName:leftInactiveTabClassName:null;

	(tabCenter!=null)?tabCenter.className=(type=='Active')?activeTabClassName:inactiveTabClassName:null;

	(link!=null)?setLinkClassName(link,type):null;

	(tabRight!=null)?tabRight.className=(type=='Active')?rightActiveTabClassName:rightInactiveTabClassName:null;
}

/***
 * Change the class name for each tab
 * @params:
 * 		tabName as String,
 * 		tabsId	as String
 * @return:
 ***/
function ChangeClassName(tab){
	//1.- I get all tabs
	var tabs = document.getElementsByName(tab.getAttribute('name'));
	var tab_position=-1;
	//2.- I travel in the tabs
	for(var i=0;i<tabs.length;i++){
		if(((tabs[i].className==activeTabClassName)||(tabs[i].className==inactiveTabClassName))){
			setClassName(	(leftInactiveTabClassName!=null)?tabs[i-1]:null,
							(inactiveTabClassName!=null)?tabs[i]:null,
							(rightInactiveTabClassName!=null)?tabs[i+1]:null,
							(linkInactiveTabClassName!=null)?tabs[i].getElementsByTagName('a'):null,
							'Inactive');
		}
		if(tabs[i]==tab) tab_position=i;
	}
	tab.className=activeTabClassName;
	setClassName(	(leftActiveTabClassName!=null)?tabs[tab_position-1]:null,
					null,
					(rightActiveTabClassName!=null)?tabs[tab_position+1]:null,
					(linkInactiveTabClassName!=null)?tabs[tab_position].getElementsByTagName('a'):null,
				    'Active');
}

/***
 * Hide or show a form
 * @params:
 * 		forms as String bidimensional array.
 * 		First position(0) content the name of the form.
 * 		Second position(1) content if that form is visible or not in a tab.
 * @return:
 ***/
function HideShowForms(forms){
	for(var i=0;i<forms.length;i++){
		form=document.getElementById(forms[i][0]+'_container');
		form.style.display=getVisibility(forms[i][1]);
	}
}

/***
 * Change class name and hide or show forms when I click in a tab
 * @params:
 * 		forms   as String bidimensional array
 * 		tabName as String
 * 		tabsId  as String
 * @return:
 ***/
function ChangeTab(Tab,forms){
	ChangeClassName(Tab);
	HideShowForms(forms);
}
